import processing.core.*; 
import processing.xml.*; 

import ddf.minim.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Galaxies extends PApplet {


AudioPlayer player;
Minim minim;

PImage b,c;
boolean cursor_show=true;

int startingTime, frame_rate;
//flags
int rayoflight=0;
int glider=0; 
int glider_counter=0;
boolean looping=true;
boolean purple=false;//whether we are searching for any purple shapes
      int purple_counter = 0;//counting new purple cells in cycle

int sx, sy;
float density = 0.06f;
int[][][] world;

int[] playlist = { 
  0, 1, 2, 3, 4
};
int playlist_counter=0;
int player_pause=0;

public void setup() 
{
  size(500, 500, P2D);
  frame.setTitle("Galaxies");
  startingTime = millis();
  
  b = loadImage("cursor.png");
  RandomBackground();
  
  cursor(b,0,0);
 

  frame_rate=12;
  frameRate(frame_rate);
  sx = width;
  sy = height;
  world = new int[sx][sy][5];
  // Set random cells to 'on' 
  for (int i = 0; i < sx * sy * density; i++) { 
    world[(int)random(sx)][(int)random(sy)][1] = 1;
  } 

  //to avoid creating a new variable for that
  //we actually use rayoflight and then set
  //it back to its original value of 0
  switch(rayoflight=(int)random(8)) {
  case 0:
    playlist[0] = 0;
    playlist[1] = 1;
    playlist[2] = 2;
    playlist[3] = 3;
    playlist[4] = 4;

    rayoflight=0;
    break;
  case 1:
    playlist[0] = 1;
    playlist[1] = 2;
    playlist[2] = 3;
    playlist[3] = 4;
    playlist[4] = 0;

    rayoflight=0;
    break;
  case 2:
    playlist[0] = 2;
    playlist[1] = 3;
    playlist[2] = 4;
    playlist[3] = 0;
    playlist[4] = 1;

    rayoflight=0;
    break;
  case 3:
    playlist[0] = 3;
    playlist[1] = 4;
    playlist[2] = 0;
    playlist[3] = 1;
    playlist[4] = 2;

    rayoflight=0;
    break;
  case 4:
    playlist[0] = 4;
    playlist[1] = 0;
    playlist[2] = 1;
    playlist[3] = 2;
    playlist[4] = 3;

    rayoflight=0;
    break;
  case 5:
    playlist[0] = 1;
    playlist[1] = 3;
    playlist[2] = 0;
    playlist[3] = 4;
    playlist[4] = 2;

    rayoflight=0;
    break;
  case 6:
    playlist[0] = 2;
    playlist[1] = 0;
    playlist[2] = 3;
    playlist[3] = 1;
    playlist[4] = 4;

    rayoflight=0;
    break;
  case 7:
    playlist[0] = 3;
    playlist[1] = 1;
    playlist[2] = 2;
    playlist[3] = 4;
    playlist[4] = 0;

    rayoflight=0;
    break;
  }

  minim = new Minim(this);

  player = minim.loadFile(playlist[playlist_counter]+".mp3",8192);
  playlist_counter++;
  player.play();
} 

public void draw() 
{ 
  background(c);

  int time = millis();

  //generating a ray of light every 5 seconds
  if(rayoflight==1 && ((time-startingTime)/5000)>1) {
    RayOfLight();   
    startingTime = time;
  }

  //generating a ray of light every 5 seconds
  if(rayoflight==2 && ((time-startingTime)/5000)>1) {
    RayOfLight2();   
    startingTime = time;
  }

  //generating a glider every second
  if(glider==1 && ((time-startingTime)/1000)>1) {
    Glider();   
    startingTime = time;
  }

  //generating a glider every second
  if(glider==2 && ((time-startingTime)/1000)>1) {
    Glider2();   
    startingTime = time;
  }

  // Drawing and update cycle 
  for (int x = 0; x < sx; x++) { 
    for (int y = 0; y < sy; y++) {

      world[x][y][3] = world[x][y][2];//storing previous-previous state
      world[x][y][2] = world[x][y][0];//storing previous state 


      //making sure two-state patterns do not get colored as life
      if(world[x][y][1] == 1 && world[x][y][3] == 1)
      {
        world[x][y][0] = 1;
        if(world[x][y][4] == 1){set(x, y, 0xffba18c8);}
        else{set(x, y, 0xff0086FF);}
      }
      if(world[x][y][1] == 0 && world[x][y][0] == 1)
      {
        world[x][y][0] = 1;//cells which existed a generation before
        if(world[x][y][4] == 1){set(x, y, 0xffba18c8);}
        else{set(x, y, 0xff0086FF);}
      }
      if ((world[x][y][1] == 1  && world[x][y][3] != 1)) 
      { 
        world[x][y][0] = 1;//new-born cells
        set(x, y, 0xffFFCC00);
        if(world[x][y][4] == 1){purple_counter++;}
      } 
      if (world[x][y][1] == -1) 
      { 
        world[x][y][0] = 0;//dead cells - empty space
      } 
      world[x][y][1] = 0;//setting next state array to 0
    
    }//y cycle
  }//x cycle

//if no new cells created by purple, purple dies 
if(purple_counter==0){purple=false;}
purple_counter=0;
 
  // Birth and death cycle 
  for (int x = 0; x < sx; x=x+1) { 
    for (int y = 0; y < sy; y=y+1) {
      int count = neighbors(x, y);
      int count2=0;
      if(purple==true) {count2 = neighbors_p(x, y);}

      if (count == 3 && world[x][y][0] == 0) 
      {
        world[x][y][1] = 1;
        if(purple==true)
              {if(count2>0) {world[x][y][4] = 1;}}
      }

      if ((count < 2 || count > 3) && world[x][y][0] == 1) 
      {
        world[x][y][1] = -1;
        world[x][y][4] = 0;
      }
    }
  }

  if(player.isPlaying()==false && player_pause!=1) {
    player.close();
    minim.stop();

    minim = new Minim(this);
    player = minim.loadFile(playlist[playlist_counter]+".mp3",8192);
    playlist_counter++;
    if(playlist_counter==5) {
      playlist_counter=0;
    }
    player.play();
  }
}//draw

// Count the number of adjacent cells 'on'
public int neighbors(int x, int y) 
{ 
  return world[(x + 1) % sx][y][0] + 
    world[x][(y + 1) % sy][0] + 
    world[(x + sx - 1) % sx][y][0] + 
    world[x][(y + sy - 1) % sy][0] + 
    world[(x + 1) % sx][(y + 1) % sy][0] + 
    world[(x + sx - 1) % sx][(y + 1) % sy][0] + 
    world[(x + sx - 1) % sx][(y + sy - 1) % sy][0] + 
    world[(x + 1) % sx][(y + sy - 1) % sy][0];
}

// Count the number of adjacent purple cells 'on'
public int neighbors_p(int x, int y) 
{ 
  return world[(x + 1) % sx][y][4] + 
    world[x][(y + 1) % sy][4] + 
    world[(x + sx - 1) % sx][y][4] + 
    world[x][(y + sy - 1) % sy][4] + 
    world[(x + 1) % sx][(y + 1) % sy][4] + 
    world[(x + sx - 1) % sx][(y + 1) % sy][4] + 
    world[(x + sx - 1) % sx][(y + sy - 1) % sy][4] + 
    world[(x + 1) % sx][(y + sy - 1) % sy][4];
}

public void mouseDragged() {

try {
    for (int i = mouseX; i < mouseX+16; i++) { 
      
        for (int ii = mouseY; ii < mouseY+16; ii++) { 
          
      world[i][ii][0] = 0;
      world[i][ii][1] = 0;
      world[i][ii][4] = 0;
        }
      }
} catch (ArrayIndexOutOfBoundsException e) {
  //do nothing
}

 }

public void mousePressed() {//erasing things in a box
  if (mouseButton == LEFT && cursor_show==true){
  noLoop();
try {
    for (int i = mouseX; i < mouseX+16; i++) { 
      
        for (int ii = mouseY; ii < mouseY+16; ii++) { 
          
      world[i][ii][0] = 0;
      world[i][ii][1] = 0;
        }
    }
   loop();
} catch (ArrayIndexOutOfBoundsException e) {
  loop();
}  
  
  }//left
  else if(mouseButton == RIGHT){
    if(cursor_show==true){
      cursor_show=false;
      noCursor();
    }
    else{
      cursor_show=true;
      cursor(b,0,0);
    }
  }//right
} 

public void keyPressed() {

  if (key == CODED) {
    if (keyCode == UP) {
      player.setGain(player.getGain()+1);
    }
    if (keyCode == DOWN) {
      player.setGain(player.getGain()-1);
      if(player.getGain()<-20) {
        player.setGain(-20);
      }
    }
    if (keyCode == RIGHT) {
      noLoop();
      player.pause();
      loop();
    }
    if (keyCode == LEFT) {
      noLoop();
      if(player.isPlaying()==false) {
        player_pause=0;
        player.play();
      }
      else {
        player_pause=1;
        player.pause();
      }
      loop();
    }
  }

  if (key == ' ') {
    if(looping) {
      noLoop();
      looping=false;
    }
    else {
      looping=true;
      loop();
    }
  }

  if (key == '=' || key == '+') {
    frameRate(60);
  }
  if (key == '-' || key == '_') {
    frameRate(12);
  }
  if (key == '0' || key == ')') {
    frameRate(5);
  }
  if (key == '9' || key == '(') {
    frameRate(1);
  }

  if (key == 'P') {
    noLoop();
    purple=true;
    if(rayoflight!=2)
    {
      rayoflight=2;//turn Ray of light on
      RayOfLight2();//force first ray so as not to wait 5 sec
    }
    else {
      rayoflight=0;
    }
    loop();
  }

  if (key == 'p') {
    noLoop();
    if(rayoflight!=1)
    {
      rayoflight=1;//turn Ray of light on
      RayOfLight();//force first ray so as not to wait 5 sec
    }
    else {
      rayoflight=0;
    }
    loop();
  }

  if (key == 'G') {
    noLoop();
    purple=true;
    if(glider!=2)
    {  
      glider=2;
    }
    else {
      glider=0;
    }
    glider_counter=0;
    loop();
  }

  if (key == 'g') {
    noLoop();
    if(glider!=1)
    {  
      glider=1;
    }
    else {
      glider=0;
    }
    glider_counter=0;
    loop();
  }


  if (key == 'R') {
    noLoop();
    purple=true;
try {
  Rpentomino2(mouseX,mouseY);//purple Rpentomino
} catch (ArrayIndexOutOfBoundsException e) {
  //that code catches an exception in case mouse cursor
  //goes out of bounds of the window and allows to place
  //the shape right near the edge (or corner)
  if((sx-mouseX<3) && (sy-mouseY<3)){
  Rpentomino2(mouseX-(3-(sx-mouseX)),mouseY-(3-(sy-mouseY)));
  }  
  else if(sy-mouseY<3){
  Rpentomino2(mouseX,mouseY-(3-(sy-mouseY)));
  }
  else if(sx-mouseX<3){
  Rpentomino2(mouseX-(3-(sx-mouseX)),mouseY);
  }

} 
    loop();
  }


  if (key == 'r') {
    noLoop();
try {
  Rpentomino(mouseX,mouseY);
} catch (ArrayIndexOutOfBoundsException e) {
  //that code catches an exception in case mouse cursor
  //goes out of bounds of the window and allows to place
  //the shape right near the edge (or corner)
  if((sx-mouseX<3) && (sy-mouseY<3)){
  Rpentomino(mouseX-(3-(sx-mouseX)),mouseY-(3-(sy-mouseY)));
  }  
  else if(sy-mouseY<3){
  Rpentomino(mouseX,mouseY-(3-(sy-mouseY)));
  }
  else if(sx-mouseX<3){
  Rpentomino(mouseX-(3-(sx-mouseX)),mouseY);
  }

} 
    loop();
  }

  if (key == 'L') {
    noLoop();
    purple=true;
    Lines2();
    loop();
  }

  if (key == 'l') {
    noLoop();
    Lines();
    loop();
  }

  if (key == 'k' || key == 'K') {
    noLoop();
    Kaleidoscope();
    loop();
  }

  if (key == 'M') {
    noLoop();
    purple=true;
    Middleship2();
    loop();
  }

  if (key == 'm') {
    noLoop();
    Middleship();
    loop();
  }

  if (key == 'B') {
    noLoop();
    purple=true;
    GGG2(sx/2-19,sy/2-19);
    loop();
  }

  if (key == 'b') {
    noLoop();
    GGG(sx/2-19,sy/2-19);
    loop();
  }

  if (key == 'V') {
    noLoop();
    purple=true;
try {
  GGG2(mouseX,mouseY);
} catch (ArrayIndexOutOfBoundsException e) {

  //that code catches an exception in case mouse cursor
  //goes out of bounds of the window and allows to place
  //the shape right near the edge (or corner)
  if((sx-mouseX<36) && (sy-mouseY<21)){
  GGG2(mouseX-(36-(sx-mouseX)),mouseY-(21-(sy-mouseY)));
  }  
  else if(sy-mouseY<21){
  GGG2(mouseX,mouseY-(21-(sy-mouseY)));
  }
  else if(sx-mouseX<36){
  GGG2(mouseX-(36-(sx-mouseX)),mouseY);
  }  

}    
    loop();
  }

  if (key == 'v') {
    noLoop();
try {
  GGG(mouseX,mouseY);
} catch (ArrayIndexOutOfBoundsException e) {

  //that code catches an exception in case mouse cursor
  //goes out of bounds of the window and allows to place
  //the shape right near the edge (or corner)
  if((sx-mouseX<36) && (sy-mouseY<21)){
  GGG(mouseX-(36-(sx-mouseX)),mouseY-(21-(sy-mouseY)));
  }  
  else if(sy-mouseY<21){
  GGG(mouseX,mouseY-(21-(sy-mouseY)));
  }
  else if(sx-mouseX<36){
  GGG(mouseX-(36-(sx-mouseX)),mouseY);
  }  

}    
    loop();
  }

  if (key == 'O') {
    noLoop();
    purple=true;
try {
  Oscillator2(mouseX,mouseY);
} catch (ArrayIndexOutOfBoundsException e) {

  //that code catches an exception in case mouse cursor
  //goes out of bounds of the window and allows to place
  //the shape right near the edge (or corner)
  if((sx-mouseX<1) && (sy-mouseY<1)){
  Oscillator2(mouseX-(1-(sx-mouseX)),mouseY-(1-(sy-mouseY)));
  }  
  else if(sy-mouseY<1){
  Oscillator2(mouseX,mouseY-(1-(sy-mouseY)));
  }
  else if(sx-mouseX<1){
  Oscillator2(mouseX-(1-(sx-mouseX)),mouseY);
  }  

}    
    loop();
  }

  if (key == 'o') {
    noLoop();
try {
  Oscillator(mouseX,mouseY);
} catch (ArrayIndexOutOfBoundsException e) {

  //that code catches an exception in case mouse cursor
  //goes out of bounds of the window and allows to place
  //the shape right near the edge (or corner)
  if((sx-mouseX<1) && (sy-mouseY<1)){
  Oscillator(mouseX-(1-(sx-mouseX)),mouseY-(1-(sy-mouseY)));
  }  
  else if(sy-mouseY<1){
  Oscillator(mouseX,mouseY-(1-(sy-mouseY)));
  }
  else if(sx-mouseX<1){
  Oscillator(mouseX-(1-(sx-mouseX)),mouseY);
  }  

}    
    loop();
  }

  if (key == 'Z') {
    noLoop();

    purple=false;

    loop();
  }

  if (key == 'z') {
    noLoop();
    rayoflight=0;
    glider=0; 
    glider_counter=0;
    purple=false;
    density=0;
    world = new int[sx][sy][5]; 
    for (int i = 0; i < sx * sy * density; i++) { 
      world[(int)random(sx)][(int)random(sy)][1] = 1;
    }
    loop();
  }

  if (key == '1' || key == '!') {
    noLoop();
    density=0.01f;
    for (int i = 0; i < sx * sy * density; i++) { 
      world[(int)random(sx)][(int)random(sy)][1] = 1;
    }
    loop();
  }
  if (key == '2' || key == '@') {
    noLoop();
    density=0.03f;
    for (int i = 0; i < sx * sy * density; i++) { 
      world[(int)random(sx)][(int)random(sy)][1] = 1;
    }
    loop();
  }  
  if (key == '3' || key == '#') {
    noLoop();
    density=0.06f;
    for (int i = 0; i < sx * sy * density; i++) { 
      world[(int)random(sx)][(int)random(sy)][1] = 1;
    }
    loop();
  }
  if (key == '4' || key == '$') {
    noLoop();
    density=0.1f;
    for (int i = 0; i < sx * sy * density; i++) { 
      world[(int)random(sx)][(int)random(sy)][1] = 1;
    }
    loop();
  }  
  if (key == '5' || key == '%') {
    noLoop();
    density=0.5f;
    for (int i = 0; i < sx * sy * density; i++) {
      world[(int)random(sx)][(int)random(sy)][1] = 1;
    }
    loop();
  }

  if (key == '6' || key == '^') {
    noLoop();
    density=0.05f;
    for (int i = 0; i < sx * sy * density; i++) {
      world[(int)random(sx)][(int)random(sy)][0] = 0;
    }
    loop();
  }
  if (key == '7' || key == '&') {
    noLoop();
    density=0.1f;
    for (int i = 0; i < sx * sy * density; i++) {
      world[(int)random(sx)][(int)random(sy)][0] = 0;
    }
    loop();
  }
  if (key == '8' || key == '*') {
    noLoop();
    density=0.5f;
    for (int i = 0; i < sx * sy * density; i++) {
      world[(int)random(sx)][(int)random(sy)][0] = 0;
    }
    loop();
  }
  if (key == '/') {
      c = loadImage("back0.png");
  }
  if (key == '?') {
      RandomBackground();
  }

}//keyPressed

public void RayOfLight() {
  //centeral ray of life which shifts around 1 pixel
  //to prevent situations where it does not give birth
  int xx= sx/2-10+(int)random(2);
  int yy= sy/2-10+(int)random(2);

  world[xx][yy][1] = 1;
  world[xx+1][yy+1][1] = 1;
  world[xx+2][yy+2][1] = 1;
  world[xx+3][yy+3][1] = 1;
  world[xx+4][yy+4][1] = 1;
  world[xx+5][yy+5][1] = 1;
  world[xx+6][yy+5][1] = 1;
  world[xx+7][yy+5][1] = 1;
  world[xx+8][yy+6][1] = 1;
  world[xx+9][yy+7][1] = 1;
  world[xx+10][yy+8][1] = 1;
}

public void RayOfLight2() {

  int xx= sx/2-10+(int)random(2);
  int yy= sy/2-10+(int)random(2);

  world[xx][yy][1] = 1;
  world[xx+1][yy+1][1] = 1;
  world[xx+2][yy+2][1] = 1;
  world[xx+3][yy+3][1] = 1;
  world[xx+4][yy+4][1] = 1;
  world[xx+5][yy+5][1] = 1;
  world[xx+6][yy+5][1] = 1;
  world[xx+7][yy+5][1] = 1;
  world[xx+8][yy+6][1] = 1;
  world[xx+9][yy+7][1] = 1;
  world[xx+10][yy+8][1] = 1;

  world[xx][yy][4] = 1;
  world[xx+1][yy+1][4] = 1;
  world[xx+2][yy+2][4] = 1;
  world[xx+3][yy+3][4] = 1;
  world[xx+4][yy+4][4] = 1;
  world[xx+5][yy+5][4] = 1;
  world[xx+6][yy+5][4] = 1;
  world[xx+7][yy+5][4] = 1;
  world[xx+8][yy+6][4] = 1;
  world[xx+9][yy+7][4] = 1;
  world[xx+10][yy+8][4] = 1;
}

public void Glider() {

  // random glider
  int glidertype=(int)random(4);//4 directions
  int xx= sx/2-1+(int)random(2);
  int yy= sy/2-1+(int)random(2);
  glider_counter++;

  if(glider_counter>99) {
    glider_counter=0;
    glider=0;
  }

  if(glidertype==0) {  
    world[xx][yy][1] = 1;
    world[xx+1][yy-1][1] = 1;
    world[xx][yy-2][1] = 1;
    world[xx-1][yy-2][1] = 1;
    world[xx+1][yy-2][1] = 1;
  }
  else if(glidertype==1) {  
    world[xx][yy][1] = 1;
    world[xx+1][yy][1] = 1;
    world[xx-1][yy-1][1] = 1;
    world[xx+1][yy-1][1] = 1;
    world[xx+1][yy-2][1] = 1;
  }
  else if(glidertype==2) {  
    world[xx][yy][1] = 1;
    world[xx-1][yy][1] = 1;
    world[xx+1][yy][1] = 1;
    world[xx-1][yy-1][1] = 1;
    world[xx][yy-2][1] = 1;
  }
  else if(glidertype==3) {  
    world[xx-1][yy][1] = 1;
    world[xx-1][yy-1][1] = 1;
    world[xx-1][yy-2][1] = 1;
    world[xx][yy-2][1] = 1;
    world[xx+1][yy-1][1] = 1;
  }
}





public void Glider2() {//purple gliderz!!!

  // random glider
  int glidertype=(int)random(4);//4 directions
  int xx= sx/2-1+(int)random(2);
  int yy= sy/2-1+(int)random(2);
  glider_counter++;

  if(glider_counter>99) {
    glider_counter=0;
    glider=0;
  }

  if(glidertype==0) {  
    world[xx][yy][1] = 1;
    world[xx+1][yy-1][1] = 1;
    world[xx][yy-2][1] = 1;
    world[xx-1][yy-2][1] = 1;
    world[xx+1][yy-2][1] = 1;

    world[xx][yy][4] = 1;
    world[xx+1][yy-1][4] = 1;
    world[xx][yy-2][4] = 1;
    world[xx-1][yy-2][4] = 1;
    world[xx+1][yy-2][4] = 1;
  }
  else if(glidertype==1) {  
    world[xx][yy][1] = 1;
    world[xx+1][yy][1] = 1;
    world[xx-1][yy-1][1] = 1;
    world[xx+1][yy-1][1] = 1;
    world[xx+1][yy-2][1] = 1;

    world[xx][yy][4] = 1;
    world[xx+1][yy][4] = 1;
    world[xx-1][yy-1][4] = 1;
    world[xx+1][yy-1][4] = 1;
    world[xx+1][yy-2][4] = 1;
  }
  else if(glidertype==2) {  
    world[xx][yy][1] = 1;
    world[xx-1][yy][1] = 1;
    world[xx+1][yy][1] = 1;
    world[xx-1][yy-1][1] = 1;
    world[xx][yy-2][1] = 1;

    world[xx][yy][4] = 1;
    world[xx-1][yy][4] = 1;
    world[xx+1][yy][4] = 1;
    world[xx-1][yy-1][4] = 1;
    world[xx][yy-2][4] = 1;
  }
  else if(glidertype==3) {  
    world[xx-1][yy][1] = 1;
    world[xx-1][yy-1][1] = 1;
    world[xx-1][yy-2][1] = 1;
    world[xx][yy-2][1] = 1;
    world[xx+1][yy-1][1] = 1;

    world[xx-1][yy][4] = 1;
    world[xx-1][yy-1][4] = 1;
    world[xx-1][yy-2][4] = 1;
    world[xx][yy-2][4] = 1;
    world[xx+1][yy-1][4] = 1;
  }
}






public void Middleship() {
  int mshiptype=(int)random(4);
  int xx= (int)random(1,(sx-7));
  int yy= (int)random(1,(sy-7));

  if(mshiptype==0) {
    world[xx][yy+2][1] = 1;
    world[xx][yy+3][1] = 1;
    world[xx][yy+4][1] = 1;

    world[xx+1][yy+1][1] = 1;
    world[xx+1][yy+4][1] = 1;

    world[xx+2][yy+4][1] = 1;

    world[xx+3][yy][1] = 1;
    world[xx+3][yy+4][1] = 1;

    world[xx+4][yy+4][1] = 1;

    world[xx+5][yy+1][1] = 1;
    world[xx+5][yy+3][1] = 1;
  }
  else if (mshiptype==1) {
    world[xx+5][yy][1] = 1;
    world[xx+5][yy+1][1] = 1;
    world[xx+5][yy+2][1] = 1;

    world[xx+4][yy][1] = 1;
    world[xx+4][yy+3][1] = 1;

    world[xx+3][yy][1] = 1;

    world[xx+2][yy][1] = 1;
    world[xx+2][yy+4][1] = 1;

    world[xx+1][yy][1] = 1;

    world[xx][yy+1][1] = 1;
    world[xx][yy+3][1] = 1;
  }
  else if (mshiptype==2) {
    world[xx][yy][1] = 1;
    world[xx][yy+1][1] = 1;
    world[xx][yy+2][1] = 1;
    world[xx][yy+3][1] = 1;
    world[xx][yy+4][1] = 1;

    world[xx+1][yy][1] = 1;
    world[xx+1][yy+5][1] = 1;

    world[xx+2][yy][1] = 1;

    world[xx+3][yy+1][1] = 1;
    world[xx+3][yy+5][1] = 1;

    world[xx+4][yy+3][1] = 1;
  }
  else if (mshiptype==3) {
    world[xx+4][yy+1][1] = 1;
    world[xx+4][yy+2][1] = 1;
    world[xx+4][yy+3][1] = 1;
    world[xx+4][yy+4][1] = 1;
    world[xx+4][yy+5][1] = 1;

    world[xx+3][yy][1] = 1;
    world[xx+3][yy+5][1] = 1;

    world[xx+2][yy+5][1] = 1;

    world[xx+1][yy][1] = 1;
    world[xx+1][yy+4][1] = 1;

    world[xx][yy+2][1] = 1;
  }
}


public void Middleship2() {
  int mshiptype=(int)random(4);
  int xx= (int)random(1,(sx-7));
  int yy= (int)random(1,(sy-7));

  if(mshiptype==0) {
    world[xx][yy+2][1] = 1;
    world[xx][yy+3][1] = 1;
    world[xx][yy+4][1] = 1;

    world[xx+1][yy+1][1] = 1;
    world[xx+1][yy+4][1] = 1;

    world[xx+2][yy+4][1] = 1;

    world[xx+3][yy][1] = 1;
    world[xx+3][yy+4][1] = 1;

    world[xx+4][yy+4][1] = 1;

    world[xx+5][yy+1][1] = 1;
    world[xx+5][yy+3][1] = 1;

    //purple
    world[xx][yy+2][4] = 1;
    world[xx][yy+3][4] = 1;
    world[xx][yy+4][4] = 1;

    world[xx+1][yy+1][4] = 1;
    world[xx+1][yy+4][4] = 1;

    world[xx+2][yy+4][4] = 1;

    world[xx+3][yy][4] = 1;
    world[xx+3][yy+4][4] = 1;

    world[xx+4][yy+4][4] = 1;

    world[xx+5][yy+1][4] = 1;
    world[xx+5][yy+3][4] = 1;
  }
  else if (mshiptype==1) {
    world[xx+5][yy][1] = 1;
    world[xx+5][yy+1][1] = 1;
    world[xx+5][yy+2][1] = 1;

    world[xx+4][yy][1] = 1;
    world[xx+4][yy+3][1] = 1;

    world[xx+3][yy][1] = 1;

    world[xx+2][yy][1] = 1;
    world[xx+2][yy+4][1] = 1;

    world[xx+1][yy][1] = 1;

    world[xx][yy+1][1] = 1;
    world[xx][yy+3][1] = 1;
    
    //purple
    world[xx+5][yy][4] = 1;
    world[xx+5][yy+1][4] = 1;
    world[xx+5][yy+2][4] = 1;

    world[xx+4][yy][4] = 1;
    world[xx+4][yy+3][4] = 1;

    world[xx+3][yy][4] = 1;

    world[xx+2][yy][4] = 1;
    world[xx+2][yy+4][4] = 1;

    world[xx+1][yy][4] = 1;

    world[xx][yy+1][4] = 1;
    world[xx][yy+3][4] = 1;
  }
  else if (mshiptype==2) {
    world[xx][yy][1] = 1;
    world[xx][yy+1][1] = 1;
    world[xx][yy+2][1] = 1;
    world[xx][yy+3][1] = 1;
    world[xx][yy+4][1] = 1;

    world[xx+1][yy][1] = 1;
    world[xx+1][yy+5][1] = 1;

    world[xx+2][yy][1] = 1;

    world[xx+3][yy+1][1] = 1;
    world[xx+3][yy+5][1] = 1;

    world[xx+4][yy+3][1] = 1;
    
    //purple
    world[xx][yy][4] = 1;
    world[xx][yy+1][4] = 1;
    world[xx][yy+2][4] = 1;
    world[xx][yy+3][4] = 1;
    world[xx][yy+4][4] = 1;

    world[xx+1][yy][4] = 1;
    world[xx+1][yy+5][4] = 1;

    world[xx+2][yy][4] = 1;

    world[xx+3][yy+1][4] = 1;
    world[xx+3][yy+5][4] = 1;

    world[xx+4][yy+3][4] = 1;
  }
  else if (mshiptype==3) {
    world[xx+4][yy+1][1] = 1;
    world[xx+4][yy+2][1] = 1;
    world[xx+4][yy+3][1] = 1;
    world[xx+4][yy+4][1] = 1;
    world[xx+4][yy+5][1] = 1;

    world[xx+3][yy][1] = 1;
    world[xx+3][yy+5][1] = 1;

    world[xx+2][yy+5][1] = 1;

    world[xx+1][yy][1] = 1;
    world[xx+1][yy+4][1] = 1;

    world[xx][yy+2][1] = 1;
    
    //purple
    world[xx+4][yy+1][4] = 1;
    world[xx+4][yy+2][4] = 1;
    world[xx+4][yy+3][4] = 1;
    world[xx+4][yy+4][4] = 1;
    world[xx+4][yy+5][4] = 1;

    world[xx+3][yy][4] = 1;
    world[xx+3][yy+5][4] = 1;

    world[xx+2][yy+5][4] = 1;

    world[xx+1][yy][4] = 1;
    world[xx+1][yy+4][4] = 1;

    world[xx][yy+2][4] = 1;
  }
}//middleship2



public void GGG(int xx,int yy) {

    //cleaning space around the shape
    for (int i = xx-9; i < xx+36; i++) { 
        for (int ii = yy-9; ii < yy+20; ii++) {          
      world[i][ii][0] = 0;
      world[i][ii][1] = 0;
        }
    }

  world[xx][yy+4][1] = 1;
  world[xx][yy+5][1] = 1;

  world[xx+1][yy+4][1] = 1;
  world[xx+1][yy+5][1] = 1;

  world[xx+10][yy+4][1] = 1;
  world[xx+10][yy+5][1] = 1;
  world[xx+10][yy+6][1] = 1;

  world[xx+11][yy+3][1] = 1;
  world[xx+11][yy+7][1] = 1;

  world[xx+12][yy+2][1] = 1;
  world[xx+12][yy+8][1] = 1;

  world[xx+13][yy+2][1] = 1;
  world[xx+13][yy+8][1] = 1;

  world[xx+14][yy+5][1] = 1;

  world[xx+15][yy+3][1] = 1;
  world[xx+15][yy+7][1] = 1;

  world[xx+16][yy+4][1] = 1;
  world[xx+16][yy+5][1] = 1;
  world[xx+16][yy+6][1] = 1;

  world[xx+17][yy+5][1] = 1;   

  world[xx+20][yy+2][1] = 1;
  world[xx+20][yy+3][1] = 1;
  world[xx+20][yy+4][1] = 1;

  world[xx+21][yy+2][1] = 1;
  world[xx+21][yy+3][1] = 1;
  world[xx+21][yy+4][1] = 1;

  world[xx+22][yy+1][1] = 1;
  world[xx+22][yy+5][1] = 1;

  world[xx+24][yy][1] = 1;
  world[xx+24][yy+1][1] = 1;
  world[xx+24][yy+5][1] = 1;
  world[xx+24][yy+6][1] = 1;

  world[xx+34][yy+2][1] = 1;
  world[xx+34][yy+3][1] = 1;

  world[xx+35][yy+2][1] = 1;
  world[xx+35][yy+3][1] = 1;
}

public void GGG2(int xx,int yy) {//purple Gosper Gun!!!

    //cleaning space around the shape
    for (int i = xx-9; i < xx+36; i++) { 
        for (int ii = yy-9; ii < yy+20; ii++) {          
      world[i][ii][0] = 0;
      world[i][ii][1] = 0;
      world[i][ii][4] = 0;
        }
    }


  world[xx][yy+4][1] = 1;
  world[xx][yy+5][1] = 1;

  world[xx+1][yy+4][1] = 1;
  world[xx+1][yy+5][1] = 1;

  world[xx+10][yy+4][1] = 1;
  world[xx+10][yy+5][1] = 1;
  world[xx+10][yy+6][1] = 1;

  world[xx+11][yy+3][1] = 1;
  world[xx+11][yy+7][1] = 1;

  world[xx+12][yy+2][1] = 1;
  world[xx+12][yy+8][1] = 1;

  world[xx+13][yy+2][1] = 1;
  world[xx+13][yy+8][1] = 1;

  world[xx+14][yy+5][1] = 1;

  world[xx+15][yy+3][1] = 1;
  world[xx+15][yy+7][1] = 1;

  world[xx+16][yy+4][1] = 1;
  world[xx+16][yy+5][1] = 1;
  world[xx+16][yy+6][1] = 1;

  world[xx+17][yy+5][1] = 1;   

  world[xx+20][yy+2][1] = 1;
  world[xx+20][yy+3][1] = 1;
  world[xx+20][yy+4][1] = 1;

  world[xx+21][yy+2][1] = 1;
  world[xx+21][yy+3][1] = 1;
  world[xx+21][yy+4][1] = 1;

  world[xx+22][yy+1][1] = 1;
  world[xx+22][yy+5][1] = 1;

  world[xx+24][yy][1] = 1;
  world[xx+24][yy+1][1] = 1;
  world[xx+24][yy+5][1] = 1;
  world[xx+24][yy+6][1] = 1;

  world[xx+34][yy+2][1] = 1;
  world[xx+34][yy+3][1] = 1;

  world[xx+35][yy+2][1] = 1;
  world[xx+35][yy+3][1] = 1;


  world[xx][yy+4][4] = 1;
  world[xx][yy+5][4] = 1;

  world[xx+1][yy+4][4] = 1;
  world[xx+1][yy+5][4] = 1;

  world[xx+10][yy+4][4] = 1;
  world[xx+10][yy+5][4] = 1;
  world[xx+10][yy+6][4] = 1;

  world[xx+11][yy+3][4] = 1;
  world[xx+11][yy+7][4] = 1;

  world[xx+12][yy+2][4] = 1;
  world[xx+12][yy+8][4] = 1;

  world[xx+13][yy+2][4] = 1;
  world[xx+13][yy+8][4] = 1;

  world[xx+14][yy+5][4] = 1;

  world[xx+15][yy+3][4] = 1;
  world[xx+15][yy+7][4] = 1;

  world[xx+16][yy+4][4] = 1;
  world[xx+16][yy+5][4] = 1;
  world[xx+16][yy+6][4] = 1;

  world[xx+17][yy+5][4] = 1;   

  world[xx+20][yy+2][4] = 1;
  world[xx+20][yy+3][4] = 1;
  world[xx+20][yy+4][4] = 1;

  world[xx+21][yy+2][4] = 1;
  world[xx+21][yy+3][4] = 1;
  world[xx+21][yy+4][4] = 1;

  world[xx+22][yy+1][4] = 1;
  world[xx+22][yy+5][4] = 1;

  world[xx+24][yy][4] = 1;
  world[xx+24][yy+1][4] = 1;
  world[xx+24][yy+5][4] = 1;
  world[xx+24][yy+6][4] = 1;

  world[xx+34][yy+2][4] = 1;
  world[xx+34][yy+3][4] = 1;

  world[xx+35][yy+2][4] = 1;
  world[xx+35][yy+3][4] = 1;
}

public void Rpentomino(int xx,int yy) {

  world[xx+1][yy][1] = 1;
  world[xx+2][yy][1] = 1;
  world[xx][yy+1][1] = 1;
  world[xx+1][yy+1][1] = 1;
  world[xx+1][yy+2][1] = 1;
}


public void Rpentomino2(int xx,int yy) {

  world[xx+1][yy][1] = 1;
  world[xx+2][yy][1] = 1;
  world[xx][yy+1][1] = 1;
  world[xx+1][yy+1][1] = 1;
  world[xx+1][yy+2][1] = 1;

  world[xx+1][yy][4] = 1;
  world[xx+2][yy][4] = 1;
  world[xx][yy+1][4] = 1;
  world[xx+1][yy+1][4] = 1;
  world[xx+1][yy+2][4] = 1;
}

public void Oscillator(int xx,int yy) {

  world[xx][yy][1] = 1;
  world[xx+1][yy][1] = 1;
  world[xx+2][yy][1] = 1;
}

public void Oscillator2(int xx,int yy) {

  world[xx][yy][1] = 1;
  world[xx+1][yy][1] = 1;
  world[xx+2][yy][1] = 1;

  world[xx][yy][4] = 1;
  world[xx+1][yy][4] = 1;
  world[xx+2][yy][4] = 1;
}

public void Lines() {
  int nn=(int)random(0,100);

  int xx= (int)random(2,(sx-2));
  int yy= (int)random(nn,(sy));

  for (int i = 0; i < nn; i++) { 
    world[xx][yy-i][1] = 1;
  }
}

public void Lines2() {
  int nn=(int)random(0,100);

  int xx= (int)random(2,(sx-2));
  int yy= (int)random(nn,(sy));

  for (int i = 0; i < nn; i++) { 
    world[xx][yy-i][1] = 1;
    world[xx][yy-i][4] = 1;
  }
}

public void Kaleidoscope() {
  int nn=(int)random(50,499);

  int xx= sx/2-1;
  int yy= (sy/2)-nn/2;

  for (int i = 0; i < nn; i++) { 
    world[xx][yy+i][1] = 1;
  }
}

public void RandomBackground(){
  int nn;
  switch(nn=(int)random(0,4)) {
  case 0:
    c = loadImage("back1.png");
    break;  
  case 1:
    c = loadImage("back2.png");
    break;
  case 2:
    c = loadImage("back3.png");
    break;
  case 3:
    c = loadImage("back4.png");
    break;
  }
}


public void stop()
{
  player.close();
  minim.stop();

  super.stop();
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#DFDFDF", "Galaxies" });
  }
}
